#define _CRT_SECURE_NO_WARNINGS
#include <stdio.h>
#include <stdlib.h>

#define MAX 100
#define FAJL_PRIJAVE "prijve.dat"
#define FAJL_PRIJAVE_TXT "prijave.txt"

#define NOVI_RED "=============================================="
#define ZAGLAVLJE "%15s%15s%15s\n"
#define STAMPAJ_RED "%15s%15d%15d\n"

typedef struct student {
	char* index;
	char* imePrezime;
	int godinaUpisa;
	//int broj_polozenih;
	//double prosek;
}STUDENT;

typedef struct predmet {
	int sifra;
	char* naziv;
}PREDMET;

typedef struct prijava {
	char brojIndeka[10];
	int sifraPredmeta;
	int ocena;
}PRIJAVA;

//podaci o prijavama se cuvaju u listi
typedef struct cvor *PCVOR;
typedef struct cvor {
	PRIJAVA podatak;
	PCVOR sledeci;
}CVOR;
void ubaci_validnu_prijavu(PCVOR *glava, STUDENT XS[], int ns, PREDMET XP[], int np);
int postoji_predmet(int sifra, PREDMET XP[], int np);
int postoji_student(char brInd[], STUDENT XS[], int ns);

PRIJAVA unos_prijave() {
	PRIJAVA p;
	printf("Unesite broj indeksa: ");
	gets(p.brojIndeka);

	printf("Unesite sifru predmeta: ");
	scanf("%d", &p.sifraPredmeta);
	
	printf("Unesite ocenu: ");
	scanf("%d", &p.ocena);
	getchar();
	return p;
}

void dodaj_prijavu_lista(PCVOR *glava, PRIJAVA p) {
	PCVOR novi = malloc(sizeof(CVOR));
	novi->podatak = p;
	novi->sledeci = *glava;
	*glava = novi;
}
void stampaj_prijavu(PRIJAVA p) {
	printf("%15s%15d%15d\n", p.brojIndeka, p.sifraPredmeta, p.ocena);
}

void prikaz_liste_prijava(PCVOR glava) {
	PCVOR tekuci = glava;
	while (tekuci != NULL) {
		stampaj_prijavu(tekuci->podatak);
		tekuci = tekuci->sledeci;
	}
}


void iz_datoteke_u_listu(char naziv_dat[], PCVOR *glava){
		PRIJAVA p;
		FILE *datoteka = fopen(naziv_dat, "rb");
		if (datoteka == NULL) {
			printf("Datoteka ne postoji!\n");
			return;
		}
		while (fread(&p, sizeof(PRIJAVA), 1, datoteka) > 0) {
			dodaj_prijavu_lista(glava, p);
		}
		fclose(datoteka);
}

void iz_liste_u_datoteku(char *naziv_dat, PCVOR glava) {
		int i;
		FILE *datoteka = fopen(naziv_dat, "wb");
		if (datoteka == NULL) {
			printf("Datoteka nije kreirana!\n");
			return;
		}
		while (glava!=NULL) {
			fwrite(&glava->podatak, sizeof(PRIJAVA), 1, datoteka);
			glava = glava->sledeci;
		}
		fclose(datoteka);
}

void listu_u_tekstnu_datoteku(char naziv_dat[], PCVOR glava) {
	FILE *datoteka = fopen(naziv_dat, "w");
	if (datoteka == NULL) {
		printf("Datoteka ne postoji!\n");
		return;
	}
	fprintf(datoteka,ZAGLAVLJE, "Indeks", "Predmet", "Ocena");
	fprintf(datoteka, "%s\n", NOVI_RED);
	while (glava != NULL) {
		fprintf(datoteka, STAMPAJ_RED, glava->podatak.brojIndeka, glava->podatak.sifraPredmeta, glava->podatak.ocena);

		glava = glava->sledeci;
	}
	fprintf(datoteka, "%s", "\n\n");

	fclose(datoteka);
}


void glavniMeni(void) {
	int izbor;
	STUDENT XS[] = {
		{"0001/2018","Marko Markovic"},
		{ "0002/2018","Tijana Tinic" },
		{ "0003/2018","Zika Zikic"},
		{ "0004/2018","Dejana Dejanic" }
	};
	PREDMET XP[] = {
		{ 1,"Programiranje 1" },
		{ 2,"Matematika 1" },
		{ 3,"OIKT" },
		{ 4,"Engleski 1" }
	};

	PCVOR glava=NULL;
	do {
		printf("*** Meni B103 - utorak ***\n");
		printf("1. Unos prijave\n");
		printf("2. Prikaz prijava\n");
		printf("3. Cuvanje prijava  u binarnoj datoteci\n");
		printf("4. Uctavanje prijava iz binarne datoteke\n");
		printf("5. Prikazi listu  u teksnoj datoteci\n");
		printf("0. Kraj rada\n");
		printf("Vas izbor (0-5): ");
		scanf("%d", &izbor);
		getchar();
		switch (izbor) {
		case 1: {
			    /*PRIJAVA p;
	            p = unos_prijave();
				dodaj_prijavu_lista(&glava, p);*/
			ubaci_validnu_prijavu(&glava,XS,4,XP,4);
            }	
			break;
		case 2: {
			printf("Prikaz svih prijava");
			getchar();
			printf("%15s%15s%15s\n", "Indeks", "Predmet", "Ocena");
			prikaz_liste_prijava(glava);
			getchar();
		}
			
			break;
		case 3:
			iz_liste_u_datoteku(FAJL_PRIJAVE, glava);
			printf("Elementi liste su prebaceni u datoteku!\n");
			break;
		case 4:
			iz_datoteke_u_listu(FAJL_PRIJAVE, &glava);
			printf("Elementi datoteke su prebacini u listu!\n");
			getchar();
			break;
		case 5:
			listu_u_tekstnu_datoteku(FAJL_PRIJAVE_TXT, glava);
			printf("Elementi liste su prikazani u tektualnoj datoteci!\n");
			break;
		case 0:
			printf("Kraj programa!\n");
			getchar();
			break;
		default:
			printf("Pogresan unos\n");
			break;
		}
	} while (izbor != 0);
}

//int globala = 10;

int main(void) {
	//int a = 10;
	glavniMeni();
	return 0;
}

void ubaci_validnu_prijavu(PCVOR *glava, STUDENT XS[],int ns, PREDMET XP[], int np) {
	int sifra;
	int ocena;
	char brojIndeksa[10];
	int postoji;
	//to do napraviti funkciju
	do {
		printf("Unesite sifru predmeta:\n ");
		scanf("%d", &sifra);
		getchar();
		postoji = postoji_predmet(sifra, XP, np);

	} while (postoji != 1);
	do {
		printf("Unesite broj indeksa:\n ");
		gets(brojIndeksa);
		postoji = postoji_student(brojIndeksa, XS, ns);
	} while (postoji != 1);
	printf("Unesite ocenu: ");
	scanf("%d", &ocena);

	PRIJAVA p;
	p.ocena = ocena;
	p.sifraPredmeta = sifra;
	strcpy(p.brojIndeka, brojIndeksa);

	dodaj_prijavu_lista(glava, p);
}

int postoji_predmet(int sifra, PREDMET XP[], int np) {
	for (int i = 0; i < np; i++) {
		if (XP[i].sifra == sifra) return 1;
	}
	return 0;
}
int postoji_student(char brInd[], STUDENT XS[], int ns) {
	for (int i = 0; i < ns; i++) {
		if (strcmp(XS[i].index, brInd) == 0) return 1;
	}
	return 0;
}

